﻿'Note that you need to add a reference to this application to your 
'Azure WCF service and call it GetCompleteAzureService for this code to compile.

Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports GetCompleteAzureService


Namespace CompetitorDisplay
	Partial Public Class MainPage
		Inherits UserControl
		Private myCompetitors As New List(Of Competitors)()

		Public Sub New()
			InitializeComponent()

			AddHandler Loaded, AddressOf MainPage_Loaded


		End Sub

		Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			LoadAzureData()
		End Sub

		Private Sub LoadAzureData()
			Dim azureSvcProxy As GetCompleteAzureService.Service1Client = New Service1Client()
			azureSvcProxy.getAllCompetitorsAsync()
			AddHandler azureSvcProxy.getAllCompetitorsCompleted, AddressOf azureSvcProxy_getAllCompetitorsCompleted
		End Sub

		Private Sub azureSvcProxy_getAllCompetitorsCompleted(ByVal sender As Object, ByVal e As getAllCompetitorsCompletedEventArgs)
			Dim competeData = e.Result
			For Each item In competeData
				Dim tempRecord As New Competitors()
				tempRecord.competeID = item.svcCompeteID
				tempRecord.competeName = item.svcCompeteName
				tempRecord.competeFY09 = item.svcCompeteFY09
				tempRecord.competeFY10 = item.svcCompeteFY10
				myCompetitors.Add(tempRecord)
			Next item

			competeList.ItemsSource = myCompetitors
		End Sub

		Private Sub MyAnimatedRectangle_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
			myStoryboard.Begin()
		End Sub

		Private Sub btnTextAnimation_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Dim textAnimation As New TextBlock()
			textAnimation.Text = "Text"
			textAnimation.Foreground = New SolidColorBrush(Colors.Black)
			LayoutRoot.Children.Add(textAnimation)

			' add a new story board to fade out the text color   
			Dim moveStoryboard As New Storyboard()

			Dim colorAnimation As New ColorAnimation()
			colorAnimation.To = Colors.White
			colorAnimation.Duration = New Duration(New TimeSpan(0, 0, 0, 0, 1))

			Storyboard.SetTarget(colorAnimation, textAnimation)
			Storyboard.SetTargetProperty(colorAnimation, New PropertyPath("(TextBlock.Foreground).(SolidColorBrush.Color)"))
			moveStoryboard.Children.Add(colorAnimation)
			moveStoryboard.Begin()
		End Sub
	End Class
End Namespace
