﻿'Note that you need to add a reference to this application to your 
'Azure WCF service and call it GetCompleteAzureService for this code to compile.

Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.SharePoint.Client
Imports CompetitorDisplayApp.GetCompleteAzureService


Namespace CompetitorDisplayApp
	Partial Public Class MainPage
		Inherits UserControl
        Private _SiteUrl As String
		Public Property SiteUrl() As String
			Get
                Return _SiteUrl
			End Get
			Set(ByVal value As String)
                _SiteUrl = value
			End Set
		End Property

		Private myCompetitors As New List(Of Competitor)()

		Public Sub New()
			InitializeComponent()

			AddHandler Loaded, AddressOf MainPage_Loaded
		End Sub

		Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			LoadAzureData()
		End Sub

		Private Sub LoadAzureData()
			Dim azureSvcProxy As GetCompleteAzureService.Service1Client = New Service1Client()
			azureSvcProxy.getAllCompetitorsAsync()
			AddHandler azureSvcProxy.getAllCompetitorsCompleted, AddressOf azureSvcProxy_getAllCompetitorsCompleted
		End Sub

		Private Sub azureSvcProxy_getAllCompetitorsCompleted(ByVal sender As Object, ByVal e As getAllCompetitorsCompletedEventArgs)
			Dim competeData = e.Result
			For Each item In competeData
				Dim tempRecord As New Competitor()
				tempRecord.competeID = item.svcCompeteID
				tempRecord.competeName = item.svcCompeteName
				tempRecord.competeFY09 = item.svcCompeteFY09
				tempRecord.competeFY10 = item.svcCompeteFY10
				myCompetitors.Add(tempRecord)
			Next item

			competeList.ItemsSource = myCompetitors
		End Sub
	End Class
End Namespace
